;(function($) {
    tinymce.PluginManager.requireLangPack('entityrefbutton');

    tinymce.create('tinymce.plugins.EntityRefButtonPlugin', {
        init: function(ed, url) {
            var plugin = this;
            plugin.buttonIDs = {};

            ed.addMTButton('entityrefbutton', {
                title: 'entityrefbutton.entityrefbutton',
                onclickFunctions: {
                    source: function(cmd, ui, val) {
                        var mode = ed.mtEditorStatus['mode'];
                        var e = ed.mtProxies[mode].e;
                        if(!e) return;
                        var text = e.getSelectedText();
                        text = __replace(text);
                        e.setSelection(text, true);
                    }
                }
            });

            function __replace(str) {
                var _str = str;
                _str = _str.replace(/&/g, "&amp;");
                _str = _str.replace(/</g, "&lt;");
                _str = _str.replace(/>/g, "&gt;");
                _str = _str.replace(/"/g, "&quote;");
                if(typeof __getCvtSpace == 'function' && __getCvtSpace()) {
                    _str = _str.replace(/ /g, "&nbsp;");
                }
                return _str;
            };
        },
        createControl: function(name, cm) {
            var editor = cm.editor;
            if(name == 'entityrefbutton') {
                var ctrl = editor.buttons[name];
                if(!this.buttonIDs[name]) {
                    this.buttonIDs[name] = [];
                }
                var id = name + '_' + this.buttonIDs[name].length;
                this.buttonIDs[name].push(id);
                return cm.createButton(id, $.extend({}, ctrl, {
                    'class': 'mce_' + name
                }));
            }
            return null;
        },
        getInfo: function() {
            return {
                longname: 'EntityRefButton plugin',
                author: 'M-Logic, Inc.',
                authorurl: 'http://m-logic.co.jp',
                infourl: 'http://m-logic.co.jp',
                version: '1.30'
            };
        }
    });
    tinymce.PluginManager.add('entityrefbutton', tinymce.plugins.EntityRefButtonPlugin);
})(jQuery);

